/********************************************************************************
    extractaudio - extract Audio0 from program streams
 ********************************************************************************
    LibVideoCoding - video coding library
    Copyright (C) 2002  Dirk Farin

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ********************************************************************************/

#include <libvideocoding/fileio/inputstream_istr.hh>
#include <libvideocoding/mpeg2/syntax/pessource.hh>
#include <libvideocoding/mpeg2/syntax/demux.hh>

#include <unistd.h>
#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <fstream>
using namespace std;
using namespace videocoding;

void Write(uint8 b)
{
  { cout << b; return; }

  static int started=0;

  if (started==2)
    { cout << b; return; }

  if (started==0 && b==0xFF)
    { started=1; return; }

  if (started==1)
    {
      if (b==0xFC)
	{
	  started=2;
	  cout << ((uint8)0xFF) << b;
	}
      else
	started=0;
    }
}


int main()
{
  try
    {
      MP2_StartCode stream = MP2_StartCode_Audio0;

      InputStream_IStream istr;
      istr.SetIStream(cin);

      MP2_ProgramStream_Decoder progdec;
      progdec.SetInputStream(istr);

      MP2_PES_Demux demux;
      demux.SetPESSource(progdec);
      demux.EnableChannel(stream);

      MP2_PES_DemuxExtractor audioextr;
      audioextr.SetSource(demux);
      audioextr.SetChannel(stream);

      for (;;)
	{
	  MP2_SystemPacket* pck = audioextr.GetNextPacket();
	  if (pck==NULL)
	    break;

	  MP2_PES_Packet* pes = dynamic_cast<MP2_PES_Packet*>(pck);
	  Assert(pes);

	  for (int i=0;i<pes->data.AskLength();i++)
	    Write(pes->data.AskData()[i]);

	  delete pes;
	}
    }
  catch (const Excpt_Base& e)
    {
      MessageDisplay::Show(e);
    }

  return 0;
}
